class Egg{
  ArrayList points = new ArrayList();
  color[] colors = new color[1];
  float[] lineWeights = new float[1];
  
  float lineWidth = 1.0;
  
  color strokeColor = color(255);
  
  float lerpCounter = 0;
  
  void egg(){
    //points = new ArrayList();
  }
  
  void draw(){
    noFill();
    if (points.size() >= 2){

      for (int i = 0; i< points.size()-1; i++){
        PVector a = (PVector) points.get(i);
        PVector b = (PVector) points.get(i + 1);
        stroke(colors[i]);
        strokeWeight(lineWeights[i+1]);
        line(a.x, a.y, a.z, b.x, b.y, b.z);
        color strokeColor = color(0);
      }
      //endShape();
      
      /* Can draw lines as single shape instead of single line
      beginShape();
      for (int i = 0; i< points.size()-1; i++){
        PVector a = (PVector) points.get(i);
        PVector b = (PVector) points.get(i + 1);
        
        stroke(findColor());
        vertex(a.x, a.y, a.z);
        color strokeColor = color(0);
      }
      endShape();
      
     */
      lerpCounter = 0;
    }
  }
  
  color findColor(){
    if (lerpCounter > 100){
      lerpCounter = 0;
    }
    color newColor = lerpColor(color(255,245,228), color(0,0,0), lerpCounter/100);
    lerpCounter++;
    return newColor;
  }
  
  void addPoint(PVector newPoint, color newColor){
    points.add(newPoint);
    lineWeights = append(lineWeights, lineWidth);
    colors = append(colors, newColor);
  }
  
  void clear(){
    points.clear();
    colors = new color[1];
    lineWeights = new float[1]; 
  }
}
